import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _initializerDefineProperty from "@babel/runtime/helpers/initializerDefineProperty";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _applyDecoratedDescriptor from "@babel/runtime/helpers/applyDecoratedDescriptor";
import _initializerWarningHelper from "@babel/runtime/helpers/initializerWarningHelper";

var _dec, _dec2, _class, _class2, _descriptor, _class3, _temp;

import _regeneratorRuntime from "@babel/runtime/regenerator";
import { ContextService } from '@antv/g';
import { inject, injectable } from 'inversify';
import { supportsPointerEvents, supportsTouchEvents, normalizeToPointerEvent } from './utils';
/**
 * listen to mouse/touch/pointer events on DOM wrapper, trigger pointer events
 */

export var DOMInteractionPlugin = (_dec = injectable(), _dec2 = inject(ContextService), _dec(_class = (_class2 = (_temp = _class3 = /*#__PURE__*/function () {
  function DOMInteractionPlugin() {
    _classCallCheck(this, DOMInteractionPlugin);

    _initializerDefineProperty(this, "contextService", _descriptor, this);
  }

  _createClass(DOMInteractionPlugin, [{
    key: "apply",
    value: function apply(renderingService) {
      var _this = this;

      var onPointerMove = function onPointerMove(ev) {
        renderingService.hooks.pointerMove.call(normalizeToPointerEvent(ev), ev);
      };

      var onPointerUp = function onPointerUp(ev) {
        renderingService.hooks.pointerUp.call(normalizeToPointerEvent(ev), ev);
      };

      var onPointerDown = function onPointerDown(ev) {
        renderingService.hooks.pointerDown.call(normalizeToPointerEvent(ev), ev);
      };

      var onPointerCancel = function onPointerCancel(ev) {
        renderingService.hooks.pointerCancel.call(normalizeToPointerEvent(ev), ev);
      };

      var onPointerOver = function onPointerOver(ev) {
        renderingService.hooks.pointerOver.call(normalizeToPointerEvent(ev), ev);
      };

      var onPointerOut = function onPointerOut(ev) {
        renderingService.hooks.pointerOut.call(normalizeToPointerEvent(ev), ev);
      };

      var onPointerWheel = function onPointerWheel(ev) {
        renderingService.hooks.pointerWheel.call(normalizeToPointerEvent(ev), ev);
      };

      renderingService.hooks.init.tap(DOMInteractionPlugin.tag, function () {
        var $el = _this.contextService.getDomElement();

        if (supportsPointerEvents) {
          self.document.addEventListener('pointermove', onPointerMove, true);
          $el.addEventListener('pointerdown', onPointerDown, true); // pointerout is fired in addition to pointerup (for touch events) and pointercancel
          // we already handle those, so for the purposes of what we do in onPointerOut, we only
          // care about the pointerleave event

          $el.addEventListener('pointerleave', onPointerOut, true);
          $el.addEventListener('pointerover', onPointerOver, true);
          self.addEventListener('pointercancel', onPointerCancel, true);
          self.addEventListener('pointerup', onPointerUp, true);
          $el.addEventListener('wheel', onPointerWheel, true);
        } else {
          self.document.addEventListener('mousemove', onPointerMove, true);
          $el.addEventListener('mousedown', onPointerDown, true);
          $el.addEventListener('mouseout', onPointerOut, true);
          $el.addEventListener('mouseover', onPointerOver, true);
          self.addEventListener('mouseup', onPointerUp, true);
          $el.addEventListener('wheel', onPointerWheel, true);
        } // always look directly for touch events so that we can provide original data
        // In a future version we should change this to being just a fallback and rely solely on
        // PointerEvents whenever available


        if (supportsTouchEvents) {
          $el.addEventListener('touchstart', onPointerDown, true);
          $el.addEventListener('touchcancel', onPointerCancel, true);
          $el.addEventListener('touchend', onPointerUp, true);
          $el.addEventListener('touchmove', onPointerMove, true);
        }
      });
      renderingService.hooks.destroy.tap(DOMInteractionPlugin.tag, /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
        var $el;
        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                $el = _this.contextService.getDomElement();

                if (supportsPointerEvents) {
                  self.document.removeEventListener('pointermove', onPointerMove, true);
                  $el.removeEventListener('pointerdown', onPointerDown, true);
                  $el.removeEventListener('pointerleave', onPointerOut, true);
                  $el.removeEventListener('pointerover', onPointerOver, true);
                  self.removeEventListener('pointercancel', onPointerCancel, true);
                  self.removeEventListener('pointerup', onPointerUp, true);
                } else {
                  self.document.removeEventListener('mousemove', onPointerMove, true);
                  $el.removeEventListener('mousedown', onPointerDown, true);
                  $el.removeEventListener('mouseout', onPointerOut, true);
                  $el.removeEventListener('mouseover', onPointerOver, true);
                  self.removeEventListener('mouseup', onPointerUp, true);
                }

                if (supportsTouchEvents) {
                  $el.removeEventListener('touchstart', onPointerDown, true);
                  $el.removeEventListener('touchcancel', onPointerCancel, true);
                  $el.removeEventListener('touchend', onPointerUp, true);
                  $el.removeEventListener('touchmove', onPointerMove, true);
                }

              case 3:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      })));
    }
  }]);

  return DOMInteractionPlugin;
}(), _class3.tag = 'DOMInteractionPlugin', _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "contextService", [_dec2], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: null
})), _class2)) || _class);
//# sourceMappingURL=DOMInteractionPlugin.js.map